Origin: upstream, https://github.com/zyantific/zydis/pull/267/commits/87a532dcf236842ad6cf770a55c1574e178059f9
Forwarded: https://github.com/zyantific/zydis/pull/267
Last-Update: 2021-11-12

--- zydis-3.2.1.orig/CMakeLists.txt
+++ zydis-3.2.1/CMakeLists.txt
@@ -37,6 +37,9 @@ option(ZYDIS_BUILD_EXAMPLES
 option(ZYDIS_BUILD_TOOLS
     "Build tools"
     ON)
+option(ZYDIS_BUILD_MAN
+    "Build manpages for the tools (requires Ronn-NG)"
+    OFF)
 option(ZYDIS_FUZZ_AFL_FAST
     "Enables AFL persistent mode and reduces prints in ZydisFuzzIn"
     OFF)
@@ -316,3 +319,23 @@ if (ZYDIS_BUILD_TOOLS AND NOT ZYAN_NO_LI
         _maybe_set_emscripten_cfg("ZydisPE")
     endif ()
 endif ()
+
+# =============================================================================================== #
+# Manpages                                                                                        #
+# =============================================================================================== #
+
+if (ZYDIS_BUILD_MAN)
+    set(MAN_NAMES "ZydisDisasm.1" "ZydisInfo.1")
+    find_program(RONN_BIN "ronn")
+    foreach(MAN_NAME ${MAN_NAMES})
+        add_custom_command(
+            OUTPUT ${MAN_NAME}
+            COMMAND ${RONN_BIN} ARGS
+                "--roff"
+                "--output-dir=${CMAKE_CURRENT_BINARY_DIR}"
+                "${CMAKE_CURRENT_SOURCE_DIR}/man/${MAN_NAME}.ronn"
+        )
+        install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${MAN_NAME}" TYPE MAN)
+    endforeach()
+    add_custom_target(man ALL DEPENDS ${MAN_NAMES})
+endif ()
--- /dev/null
+++ zydis-3.2.1/man/ZydisDisasm.1.ronn
@@ -0,0 +1,35 @@
+ZydisDisasm(1) -- disassemble files
+===================================
+
+## SYNOPSIS
+
+`ZydisDisasm -[real|16|32|64] <input file>`
+
+## DESCRIPTION
+
+ZydisDisasm allows you to decode X86 & X86-64 assembly files, dumping the disassembled instructions to stdout.
+
+## EXAMPLES
+
+    $ ZydisDisasm -64 input.hex
+    and byte ptr ds:[rbx], dh
+    and byte ptr ds:[r14], r14b
+    xor eax, 0x20453220
+    xor byte ptr ds:[rax], r12b
+    xor r12b, byte ptr ds:[rax]
+    xor r12d, dword ptr ds:[rax]
+    xor al, 0x38
+    and byte ptr ds:[rax], dh
+    xor dword ptr ds:[rax], esp
+    xor al, 0x20
+    cmp dword ptr ds:[rax], edi
+    and byte ptr ds:[rdx], dh
+    and byte ptr ds:[r8], sil
+    xor dword ptr ds:[rax], esp
+    xor byte ptr ds:[rax], dh
+    and byte ptr ds:[rax], dh
+    xor byte ptr ds:[rdx], cl
+
+## SEE ALSO
+
+ZydisInfo(1)
--- /dev/null
+++ zydis-3.2.1/man/ZydisInfo.1.ronn
@@ -0,0 +1,30 @@
+ZydisInfo(1) -- disassemble in your terminal
+============================================
+
+## SYNOPSIS
+
+`ZydisInfo -[real|16|32|64] <hexbytes>`
+
+## DESCRIPTION
+
+ZydisInfo allows you to decode X86 & X86-64 assembly displaying lots of information about it.
+
+## EXAMPLES
+
+    $ ZydisInfo -64 66 3E 65 2E F0 F2 F3 48 01 A4 98 2C 01 00 00
+    == [    BASIC ] ==================================================
+       MNEMONIC: add [ENC: DEFAULT, MAP: DEFAULT, OPC: 0x01]
+         LENGTH: 15
+            SSZ: 64
+           EOSZ: 64
+           EASZ: 64
+       CATEGORY: BINARY
+        ISA-SET: I86
+        ISA-EXT: BASE
+     EXCEPTIONS: NONE
+     ATTRIBUTES: HAS_MODRM HAS_SIB HAS_REX CPUFLAG_ACCESS ACCEPTS_LOCK
+    [...more info...]
+
+## SEE ALSO
+
+ZydisDisasm(1)
